require 'rubygems'
require 'yaml'
require 'optparse'
require 'amqp'
require 'json'
require 'logger'

$:.push File.expand_path("../lib")

require 'manband/flowconfig.rb'
require 'manband/util.rb'


# The program sends a message operation to the workflow control to ack a job.
# This program does not need database credentials but needs AMQP_URL set.
# Author: Olivier Sallou <olivier.sallou@irisa.fr>
# Copyright: 2012, IRISA


log = Logger.new(STDOUT)
log.level = Logger::INFO

options = {}

optparse = OptionParser.new do|opts|
  
  # This displays the help screen, all programs are
  # assumed to have this option.
  opts.on( '-h', '--help', 'Display this screen' ) do
    puts opts
    exit
  end

  options[:workflow] = nil
  opts.on( '-w', '--workflow ID', 'Id of the worflow') do |id|
    options[:workflow] = id
  end

  options[:job] = nil
  opts.on( '-j', '--job ID', 'Job id') do |id|
    options[:job] = id
  end

  options[:instance] = 0
  opts.on( '-i', '--instance ID', 'Job instance number, defaults to 0') do |id|
    options[:instance] = id
  end

  options[:handler] = 'interactive'
  opts.on( '-d', '--handler NAME', 'Handler name, defaults to interactive') do |id|
    options[:handler] = id
  end

end

optparse.parse!

if options[:workflow]==nil || options[:job]==nil
  puts "Missing parameter!"
  exit
end

msg = '{ "workflow" : "'+options[:workflow].to_s+'" ,  "id" : "'+options[:job].to_s+'", "handler" : "'+options[:handler].to_s+'", "instance" : "'+options[:instance].to_s+'" }'

Utils.publish('manband.master',{ "operation" => "finish", "msg" => msg })

