require 'uuid'
require 'data_mapper'
require 'dm-migrations'

require 'manband/flowconfig.rb'

#DataMapper.setup(:default, 'sqlite:///tmp/project.db')
DataMapper.setup(:default, ENV['MYSQL_URL'])

# This class manages users in the database
class User
  include DataMapper::Resource

  @@admin = 'admin'

  property :login, String, :key => true # User login
  property :password, String # USer password
  property :s3_access, String # User id key
  property :s3_secret, String # Secret key

  # Creates a default admin account if it does not exists.
  # Default password is <b>admin</b>
  def self.init
    admin = User.get(@@admin)
    if admin == nil
      uuid = UUID.new
      admin = User.new(:login => @@admin, :password => Digest::SHA1.hexdigest('admin'))
      admin.save
    end
  end

  # Check passwords
  # password: user password
  # @return: true if authentication is correct
  def authenticate(password)
    shapwd = Digest::SHA1.hexdigest(password) 
    if self.password == shapwd
      return true
    end
    return false; 
  end

  def self.admin
    return @@admin
  end

end

DataMapper.finalize
DataMapper.auto_upgrade!

User.init()

